Base Distribution - Task # 54080

Work Package # 47023 (Accepted): Global user interface
Task # 48071 (Resolved): Navigate component

Status: Resolved Priority: Must have

Author: Bastian Waidelich Category: Content Repository
Created: 2013-11-29 Assigned To: Bastian Waidelich
Updated: 2013-12-20 Due date:

Subject: As a content editor | want to be able to move pages

Description

Moving/renaming document nodes currently has some weird side-effects:

Moving a page that is not selected

Expected: The navigate component should be reloaded, the current page should still be selected
Actual: The current page stays selected as expected, but it's not possible to navigate to the moved page, Browser refresh required

01_move_other_page.png

Moving the currently selected page

Expected: The navigate component should be reloaded, the moved page should be selected

Actual: The current page stays selected but with the old node path leading to "tree load errors. Browser refresh leads to 404.
Navigation to "/neos" required

02_move_selected_page.png

Renaming a page

Expected: The navigate component should be reloaded, the renamed page should be selected
Actual: The current page stays selected but with the old node path and name, Browser refresh required

see #53610

03_rename_a_page.png

Moving a page creating a tree conflict

Expected: A.) It should not be possible to move the page B.) A "human readable" error should be shown, refreshing the navigate
component with the previous state
Actual: An ExtDirect error is displayed, navigate component "dies" with a loading animation. Browser refresh required

04_tree_conflict.png

Renaming a page creating an irreversible tree conflict

Expected: A.) It should not be possible to rename the page to an existing node name B.) A "human readable" error should be shown,
restoring the previous state

Actual: The navigate component selects the other page with the same node name, publishing leads to an invalid CR state that can
only be solved by fixing the db directly!

05_break_CR.png

Measures

We should start with behat tests covering all common tree interactions (moveAfter, moveln, moveBefore, rename) with and without
publishing
Related issues:

related to TYPOS3.Neos - Task # 53610: Navigate component breaks when changing... Resolved
related to TYPO3.Neos - Bug # 54355: rename Name(URL) is not working properly Closed
duplicated by TYPO3.Neos - Bug # 54192: Menus don't respect deleted pages Closed

2013-11-13
2013-12-12
2013-12-04

Associated revisions

Revision 9f3b3b94 - 2013-12-07 10:50 - Bastian Waidelich

[BUGFIX] Prevent corrupted node trees

Currently if two nodes with the same path are in the same workspace,
an exception is thrown putting Neos into an irreversible state.

This change adds a unique index so that duplicate paths are prevented
on the database level.

Note: This is only a safeguard to prevent the incorrect state from
being persisted. When publishing a node with a duplicate path now,
still an exception is thrown. But at least the state is now

reversible through the Ul (by discarding the workspace changes).

Background:

Simply adding a unique index over the "path" and "workspace" columns
did not work out, because of the large columns. This is the reason

for the new column "hashedPath" that always contains the MD5 hash of
the current path.

In a future change we can adjust some of the node lookups to compare
the value with a pre-calculated hash over the path for a possible
performance boost.

Change-Id: 175faece045ae2df9249744956886¢2700291fb64
Related: #54080
Reviewed-on: https://review.typo3.0rg/25974

Reviewed-by: Christopher Hlubek
Tested-by: Christopher Hlubek
Reviewed-by: Christian Mueller

Tested-by: Christian Mueller

Revision a7d5695e - 2013-12-09 01:24 - Christopher Hlubek

[BUGFIX] Fix the moving of the currently selected node in the page tree

- Reload the tree correctly if moving a selected page
- Load the correct page of the selected page at the moved URL

Change-Id: 11ae5a37439180382cc906e5fdb43d79593df0c1 1
Related: #54080
Reviewed-on: https://review.typo3.0rg/26085

Reviewed-by: Tim Kandel
Tested-by: Tim Kandel
Reviewed-by: Christopher Hlubek
Tested-by: Christopher Hlubek
https://review.typo3.org/25974
https://review.typo3.org/26085

History

#1 - 2013-12-04 19:54 - Aske Ertmann
- Parent task changed from #40297 to #48071

#2 - 2013-12-07 13:36 - Bastian Waidelich
- Assigned To deleted (Christian Mtiller)

#3 - 2013-12-20 17:36 - Bastian Waidelich
- Status changed from New to Resolved

- Assigned To set to Bastian Waidelich
- % Done changed from 0 to 100

Those issues are mostly resolved with 1.0!
